/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package protosms;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.URLEncoder;
import java.net.UnknownHostException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author jdt
 */
public class SMS {

    private String telephone;
    private String message;
    private String username;
    private String password;

    private static String host = "123-sms.net";
    private static int port = 80;

    public SMS(String telephone, String message, String username, String password) {
        this.telephone = telephone;
        this.message = message;
        this.username = username;
        this.password = password;
    }


    public SMSReturnCode send() throws IOException{

        Socket echoSocket = null;
        PrintWriter out = null;
        BufferedReader in = null;

        // connect to the socket
        try {
            echoSocket = new Socket(host, port);
            out = new PrintWriter(echoSocket.getOutputStream(), true);
            in = new BufferedReader(new InputStreamReader(echoSocket.getInputStream()));
        }
        catch (UnknownHostException ex) { Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);}
        catch (IOException ex) { Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);}

        BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));
        message = message.replace("\r\n", "***"); // CRLF coding for 123sms

        String requete = "email="+username+"&pass="+password+"&message="+URLEncoder.encode(message,"ISO-8859-1")+"&numero="+telephone;

        String entete = "POST /http.php HTTP/1.1\r\n";
	entete += "Host: "+host+"\r\n";
        entete += "Content-Type: application/x-www-form-urlencoded\r\n";
        entete += "Content-Length: "+requete.length()+"\r\n";
        entete += "Connection: close\r\n\r\n";
        entete += requete+"\r\n";

        // send query
        out.println(entete);

        String result = null;
        int errorCode = 0;
        int index = 0;
        while( (result = in.readLine()) != null){            
            if(index==9) //line for result
                errorCode = Integer.valueOf(result); // last line
            index++;
        }               

        // close socket
	out.close();
	in.close();
	stdIn.close();
	echoSocket.close();

        return SMSReturnCode.getReturnCodeByNumber(errorCode);
    }

    /**
     * Get the value of username
     *
     * @return the value of username
     */
    public String getUsername() {
        return username;
    }

    /**
     * Set the value of username
     *
     * @param username new value of username
     */
    public void setUsername(String username) {
        this.username = username;
    }

    /**
     * Get the value of password
     *
     * @return the value of password
     */
    public String getPassword() {
        return password;
    }

    /**
     * Set the value of password
     *
     * @param password new value of password
     */
    public void setPassword(String password) {
        this.password = password;
    }

    /**
     * Get the value of message
     *
     * @return the value of message
     */
    public String getMessage() {
        return message;
    }

    /**
     * Set the value of message
     *
     * @param message new value of message
     */
    public void setMessage(String message) {
        this.message = message;
    }


    /**
     * Get the value of telephone
     *
     * @return the value of telephone
     */
    public String getTelephone() {
        return telephone;
    }

    /**
     * Set the value of telephone
     *
     * @param telephone new value of telephone
     */
    public void setTelephone(String telephone) {
        this.telephone = telephone;
    }


}
